import { CharStreams, CommonTokenStream, Parser } from 'antlr4ng';
import { PostgreSqlParser, } from '../generated/PostgreSqlParser.js';
import { PostgreSqlLexer } from '../generated/PostgreSqlLexer.js';
class PostgreSqlParserBase extends Parser {
    GetParsedSqlTree(script) {
        const ph = this.getPostgreSQLParser(script);
        const result = ph.root();
        return result;
    }
    ParseRoutineBody(_localctx) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
        let lang = null;
        for (const coi of _localctx.createfunc_opt_item()) {
            if (coi.LANGUAGE() !== null) {
                if (coi.nonreservedword_or_sconst() !== null)
                    if (((_a = coi.nonreservedword_or_sconst()) === null || _a === void 0 ? void 0 : _a.nonreservedword()) !== null)
                        if (((_c = (_b = coi.nonreservedword_or_sconst()) === null || _b === void 0 ? void 0 : _b.nonreservedword()) === null || _c === void 0 ? void 0 : _c.identifier()) !==
                            null)
                            if (((_f = (_e = (_d = coi
                                .nonreservedword_or_sconst()) === null || _d === void 0 ? void 0 : _d.nonreservedword()) === null || _e === void 0 ? void 0 : _e.identifier()) === null || _f === void 0 ? void 0 : _f.Identifier()) !== null) {
                                lang = (_k = (_j = (_h = (_g = coi
                                    .nonreservedword_or_sconst()) === null || _g === void 0 ? void 0 : _g.nonreservedword()) === null || _h === void 0 ? void 0 : _h.identifier()) === null || _j === void 0 ? void 0 : _j.Identifier()) === null || _k === void 0 ? void 0 : _k.getText();
                                break;
                            }
            }
        }
        if (null === lang)
            return;
        let func_as = null;
        for (const a of _localctx.createfunc_opt_item()) {
            if (a.func_as() !== null) {
                func_as = a;
                break;
            }
        }
        if (func_as !== null) {
            // @ts-ignore
            const txt = this.GetRoutineBodyString((_l = func_as.func_as()) === null || _l === void 0 ? void 0 : _l.sconst(0));
            const ph = this.getPostgreSQLParser(txt);
            switch (lang) {
                case 'plpgsql':
                    // @ts-ignore
                    func_as.func_as().Definition = ph.plsqlroot();
                    break;
                case 'sql':
                    // @ts-ignore
                    func_as.func_as().Definition = ph.root();
                    break;
            }
        }
    }
    unquote(s) {
        const slength = s.length;
        let r = '';
        let i = 0;
        while (i < slength) {
            const c = s.charAt(i);
            r += c;
            if (c === "'" && i < slength - 1 && s.charAt(i + 1) === "'")
                i++;
            i++;
        }
        return r;
    }
    GetRoutineBodyString(rule) {
        const anysconst = rule.anysconst();
        const StringConstant = anysconst.StringConstant();
        if (null !== StringConstant)
            return this.unquote(this.TrimQuotes(StringConstant.getText()));
        const UnicodeEscapeStringConstant = anysconst.UnicodeEscapeStringConstant();
        if (null !== UnicodeEscapeStringConstant)
            return this.TrimQuotes(UnicodeEscapeStringConstant.getText());
        const EscapeStringConstant = anysconst.EscapeStringConstant();
        if (null !== EscapeStringConstant)
            return this.TrimQuotes(EscapeStringConstant.getText());
        let result = '';
        const dollartext = anysconst.DollarText();
        for (const s of dollartext) {
            result += s.getText();
        }
        return result;
    }
    getPostgreSQLParser(script) {
        const charStream = CharStreams.fromString(script);
        const lexer = new PostgreSqlLexer(charStream);
        const tokens = new CommonTokenStream(lexer);
        const parser = new PostgreSqlParser(tokens);
        return parser;
    }
    TrimQuotes(s) {
        return s === null || s.length === 0 ? s : s.substring(1, s.length - 1);
    }
}
export default PostgreSqlParserBase;
